<%@ Page Language="C#" %>
<%@ Register TagPrefix="telerik" Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">
	
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Untitled Page</title>
    
    <style type="text/css">
    
		span.CutNode
		{
			color: gray;
		}
    </style>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:ScriptManager runat="server" ID="ScriptManager1" />
        <script type="text/javascript">
        //Array which contains copied and cut clipBoard
        var clipBoard = [];
        //Current operation "copy" or "cut"
        var currentOperation = "";
        
        function cutToNormal()
        {
			//Restore the appearance of clipBoard which were made to look "cut"
			for (var i = 0; i < clipBoard.length; i++)
			{
				clipBoard[i].set_cssClass(clipBoard[i].oldCssClass);
				delete clipBoard[i].oldCssClass;
			}
        }
        
        function normalToCut()
        {
			//Apply a custom CSS class to make the clipBoard look "cut"
			for (var i = 0; i < clipBoard.length; i++)
			{
				clipBoard[i].oldCssClass = clipBoard[i].get_cssClass();
				clipBoard[i].set_cssClass("CutNode");
			}
        }
        
        function copyNode(node)
		{
			var copy = new Telerik.Web.UI.RadTreeNode();
			
			//Copy any other properties required by your scenario
			copy.set_text(node.get_text());
			copy.set_expanded(node.get_expanded());
			
			for (var i = 0; i < node.get_nodes().get_count(); i++)
			{
				copy.get_nodes().add(copyNode(node.get_nodes().getNode(i)));
			}
			
			return copy;
		}
		
		function performOperation(destNode, operation)
		{
			var destElement = destNode.get_element();
			var pastedNodes = [];
			for (var i = 0; i < clipBoard.length; i++)
			{
				var node = clipBoard[i];
				//Avoid pasting a parent node onto its child or onto itself
				if (!$telerik.isDescendant(node.get_element(), destElement) && node != destNode)
				{
					//avoid pasting children of already pasted clipBoard
					if (!alreadyPasted(pastedNodes, node))
						operation(destNode, node);
					pastedNodes[pastedNodes.length] = node;
				}
			}
			
			cutToNormal();
			
			destNode.expand();
		}
		
        function performCut(node)
        {
			performOperation(node, function(destNode, sourceNode) {
					destNode.get_nodes().add(sourceNode);		
				}
			);
			
			//clean up the temporary array in which copied and cut clipBoard are stored
			clipBoard = [];
        }
		function performCopy(node)
		{
			performOperation(node, function(destNode, sourceNode) {
					destNode.get_nodes().add(copyNode(sourceNode));
				}
			);
		}
		
        function alreadyPasted(pastedNodes, node)
        {
			for (var i = 0; i < pastedNodes.length; i++)
			{
				if ($telerik.isDescendant(pastedNodes[i].get_element(), node.get_element()))
					return true;
			}
			
			return false;
        }
		
		function sortNodesByLevel(node1, node2)
		{
			return node1.get_level() - node2.get_level();
		}
		
        function onKeyPressing(sender, args)
        {
            //Get the browser DOM event
            var e = args.get_domEvent();
            //Get the current node
            var destNode = args.get_node();
            
            if (isCut(e))
			{
				currentOperation = "cut";
				cutToNormal();
				clipBoard = sender.get_selectedNodes();
				clipBoard.sort(sortNodesByLevel);
				normalToCut();
			}
			else if (isCopy(e))
			{
				currentOperation = "copy";
				cutToNormal();
				clipBoard = sender.get_selectedNodes();
				clipBoard.sort(sortNodesByLevel);
			}
			else if (isPaste(e))
			{
				if (clipBoard.length < 1)
					return;
				//Optional
				sender.trackChanges();
				
				if (currentOperation == "cut")
					performCut(destNode);
				else if (currentOperation == "copy")
					performCopy(destNode);
				//Optional
				sender.commitChanges();
			}
        }
        
        
        function isPaste(e)
        {
			//CTRL + V
			if (e.keyCode == 86 && e.ctrlKey) 
                return true;
            //SHIFT + INS
            if (e.keyCode == 45 && e.shiftKey)
                return true;
        }
        
        function isCopy(e)
        {
			//CTRL + C
			if (e.keyCode == 67 && e.ctrlKey) 
                return true;
            //CTRL + INS
            if (e.keyCode == 45 && e.ctrlKey)
                return true;
        }
        
        function isCut(e)
        {
            //CTRL + X
            if (e.keyCode == 88 && e.ctrlKey) 
                return true;
            //SHIFT + DEL
            if (e.keyCode == 127 && e.shiftKey)
                return true;
                
            return false;
        }
        
        </script>
        <telerik:RadTreeView runat="Server" ID="RadTreeView1" OnClientKeyPressing="onKeyPressing" TabIndex="1" MultipleSelect="true">
            <Nodes>
                <telerik:RadTreeNode runat="server" Text="Root RadTreeNode1" Expanded="true">
                    <Nodes>
                        <telerik:RadTreeNode runat="server" Text="Child RadTreeNode 1">
                        </telerik:RadTreeNode>
                    </Nodes>
                </telerik:RadTreeNode>
                <telerik:RadTreeNode runat="server" Text="Root RadTreeNode2" Expanded="true">
                    <Nodes>
                        <telerik:RadTreeNode runat="server" Text="Child RadTreeNode 1">
                        </telerik:RadTreeNode>
                    </Nodes>
                </telerik:RadTreeNode>
                <telerik:RadTreeNode runat="server" Text="Root RadTreeNode3" Expanded="true">
                    <Nodes>
                        <telerik:RadTreeNode runat="server" Text="Child RadTreeNode 1">
                        </telerik:RadTreeNode>
                    </Nodes>
                </telerik:RadTreeNode>
            </Nodes>
        </telerik:RadTreeView>
    </div>
    </form>
</body>
</html>
